import {
  ClassType,
  PropertyType,
} from '@loafer/core/constants/types';

import {
  Class,
} from '@loafer/core/reflect';

export interface Annotation {
  onClassDecorator?: <TFunction extends Function>(target: TFunction) => TFunction | void;
  onPropertyDecorator?: (target: Object, propertyKey: PropertyType) => void;
  onMethodDecorator?: <T>(target: Object, propertyKey: PropertyType,
                          descriptor: TypedPropertyDescriptor<T>) => TypedPropertyDescriptor<T> | void;
  onParameterDecorator?: (target: Object, propertyKey: PropertyType, parameterIndex: number) => void;
}

export abstract class Annotation {

}

export default Annotation;
