import {
  ClassType,
} from '@loafer/core/constants/types';

import AnnotatedElement from './AnnotatedElement';
import Parameter from '@loafer/core/reflect/Parameter';

export abstract class Executable extends AnnotatedElement {
  protected _parameters: Parameter[];

  public constructor(parameterTypes: ClassType[]) {
    super();

    this._parameters = [];
    parameterTypes.forEach((currentValue, index, array) => {
      this._parameters.push(new Parameter(currentValue, index));
    });
  }

  public get Parameters(): Parameter[] {
    return this._parameters;
  }

  public getParameter(index: number): Parameter {
    return this._parameters[index];
  }

}

export default Executable;
