import {
  ClassType,
  PropertyType,
} from '@loafer/core/constants/types';

import Executable from '@loafer/core/reflect/Executable';


export class Method extends Executable {
  private _name: PropertyType;
  private _returnType: ClassType;

  public constructor(name: PropertyType, parameterTypes: ClassType[], returnType: ClassType) {
    super(parameterTypes);
    this._name = name;
    this._returnType = returnType;
  }

  public get Name(): PropertyType {
    return this._name;
  }
  public get ReturnType(): ClassType {
    return this._returnType;
  }

  public set ReturnType(returnType: ClassType) {
    this._returnType = returnType;
  }

}

export default Method;
