import {
  PropertyType,
} from '@loafer/core/constants/types';

import {
  Decorator,
 } from '@loafer/core/decorator';

import Annotation from '@loafer/core/annotation/Annotation';

export class InjectableAnnotation extends Annotation {
  private readonly Qualifier: PropertyType;

  public constructor(qualifier?: PropertyType) {
    super();
    this.Qualifier = qualifier;
  }
  public onClassDecorator = <TFunction extends Function>(target: TFunction): TFunction | void => {
    console.log('Injectable');
  }

}

export const Injectable = Decorator.create(InjectableAnnotation);

export default Injectable;
