import {
  ClassType,
  PropertyType,
} from '@loafer/core/constants/types';

import {
  Decorator,
} from '@loafer/core/decorator';

import Annotation from '@loafer/core/annotation/Annotation';

export class ValueAnnotation extends Annotation {
  private readonly Value: PropertyType;

  public constructor(value: PropertyType) {
    super();
    this.Value = value;
  }

  public onPropertyDecorator = (target: Object, propertyKey: PropertyType): void => {
    console.log('Value');
  }
  public onParameterDecorator = (target: Object, propertyKey: PropertyType, parameterIndex: number): void => {
    console.log('Value');
  }

}

export const Value = Decorator.create(ValueAnnotation);

export default Value;
