import {
  ClassType,
  PropertyType,
} from '@loafer/core/constants/types';

import SingletonPouchRegistry from '@loafer/pouches/factory/config/SingletonPouchRegistry';

class DefaultSingletonPouchRegistry implements SingletonPouchRegistry {
  protected singletonInstanceMap: Map<PropertyType, Map<ClassType, any>>;

  protected constructor() {
    this.singletonInstanceMap = new Map();
  }

  public registerSingleton(pouch: any, qualifier?: PropertyType): void {
    let clazz: ClassType = Object.getPrototypeOf(pouch);
    // const _qualifier = validateQualifier(clazz, qualifier);

    // if (this._hasSingleton(_qualifier, clazz)) {
    //   throw new Error(`Pouch Definition[${clazz.constructor.name}:${qualifier}] is exist already`);
    // }
    // let map = this.singletonInstanceMap.get(_qualifier);
    // if (undefined === map) {
    //   map = new Map();
    //   this.singletonInstanceMap.set(_qualifier, map);
    // }
    // map.set(clazz, pouch);
  }

  public getSingleton(qualifier: PropertyType, clazz?: ClassType): any {
    return this._getSingleton(qualifier, clazz);
  }
  public getSingletonByClass(clazz: ClassType, qualifier?: PropertyType): any {
    // const _qualifier = validateQualifier(clazz, qualifier);
    return this._getSingleton(qualifier, clazz);
  }
  public hasSingleton(qualifier: PropertyType, clazz?: ClassType): boolean {
    return this._hasSingleton(qualifier, clazz);
  }
  public hasSingletonByClass(clazz: ClassType, qualifier?: PropertyType): boolean {
    // const _qualifier = validateQualifier(clazz, qualifier);
    return this._hasSingleton(qualifier, clazz);
  }


  private _getSingleton<T>(qualifier: PropertyType, clazz?: ClassType): T {
    if (!this.singletonInstanceMap.has(qualifier)) {
      return undefined;
    }
    let map = this.singletonInstanceMap.get(qualifier);
    let instance;
    try {
      instance = this._getInstance(map, clazz);
    } catch(e) {
      throw new Error(`Type of Pouch[${qualifier}] cannot be specified(count is ${map.size}).`);
    }
    return instance;
  }

  private _hasSingleton(qualifier: PropertyType, clazz?: ClassType): boolean {
    return undefined === this._getSingleton(qualifier, clazz) ? false : true;
  }

  private _getInstance(map: Map<ClassType, any>, clazz?: ClassType): any {
    if (undefined !== clazz) {
      return map.get(clazz);
    }
    const count = map.size;
    if (1 < count) {
      throw new Error(`Type of Pouch cannot be specified(count is ${count}).`);
    }
    for (let value of Array.from(map.values())) {
      return value;
    }
  }
}

export default DefaultSingletonPouchRegistry;
