import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeEvery } from 'redux-saga/effects';

import { SagaWatcher } from '@overflow/commons/constant';
import Action from '@overflow/commons/redux/Action';
import * as AsyncRequestActions  from '@overflow/commons/redux/action/asyncRequest';

import WebSocketRPC from '@overflow/commons/websocket/WebSocketRPC';

import AsyncRequestPayload from '../payload/AsyncRequestPayload';

function* request(action: Action<AsyncRequestPayload>): SagaIterator {
  const {service, method, requestType, args} = action.payload;

  try {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });`${service}.${method}`
    // let webSocketRPC: WebSocketRPC = GetAppContext().getPouchByClass(WebSocketRPC.prototype, undefined);
    // let result = yield call({context: webSocketRPC, fn: webSocketRPC.Call}, `${service}.${method}`, args);

    // yield put(AsyncRequestActions.requestSuccess(requestType, result));
  } catch (e) {
    yield put(AsyncRequestActions.requestFailure(requestType, e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

function* watchAsyncRequest(): SagaIterator {
  yield takeEvery(AsyncRequestActions.REQUEST, request);
}

const sagaWatchers: SagaWatcher[] = [watchAsyncRequest];

export default sagaWatchers;
